import { AwsCdkConstructLibrary, NodePackageManager, ProjectType } from 'projen'
const project = new AwsCdkConstructLibrary({
  author: 'Greg Farrow',
  authorAddress: 'g-farrow@users.noreply.github.com',
  cdkVersion: '1.109.0',
  defaultReleaseBranch: 'main',
  name: 'mt-awscdk-constructs',
  description: 'Marley Tech AWS CDK Construct Library',
  repositoryUrl: 'https://github.com/marleytech/mt-awscdk-constructs.git',
  projenrcTs: true,
  projectType: ProjectType.LIB,
  packageManager: NodePackageManager.NPM,
  eslintOptions: {
    dirs: ['src'],
    prettier: true,
  },
  docsDirectory: 'docs',
  python: {
    distName: 'mt-awscdk-constructs',
    module: 'mt_awscdk_constructs',
  },
  gitignore: ['.idea', '.vscode'],
  cdkDependencies: [
    '@aws-cdk/core',
    '@aws-cdk/aws-lambda',
    '@aws-cdk/aws-events-targets',
    '@aws-cdk/aws-events',
    '@aws-cdk/aws-sqs',
    '@aws-cdk/aws-cloudwatch-actions',
    '@aws-cdk/aws-cloudwatch',
    '@aws-cdk/aws-sns',
  ],
  license: 'MIT',
})
project.eslint.addOverride({ files: ['*'], rules: { semi: 0 } })
project.synth()
